// Copyright 2022 hjiayz
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
// 
//     http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

import fs from "fs";
import RegExp2Rust from "./index.js";
import child_process from 'child_process';

//let reg = /abc(def)(?<=def)(?=123)(?<!dee)(?!122)(?<Name>123)/u;
let reg = /12(?!(4))/u;
let program = new RegExp2Rust(reg).build();
let s = "123";
program=`fn main(){${program}        assert!(dbg!(exec("${s}"))[0].is_some()==${reg.test(s)});\n}`
fs.writeFileSync('./example.rs', program, 'utf8');
if (!fs.existsSync("./target")) {
    fs.mkdirSync("./target");
}
let result = child_process.spawnSync('rustc', ['-o', './target/run.exe' , './example.rs']);
if (result.status !==0) {
    console.log(result.stdout.toString());
    console.log(result.stderr.toString());
    process.exit();
}
result = child_process.spawnSync('./target/run.exe');
console.log(result.stdout.toString());
console.log(result.stderr.toString());
